com.ihr.xbrl.dts

## Class FactUseItem

- java.lang.Object
- - com.ihr.xbrl.dts.FactUse
  - - com.ihr.xbrl.dts.FactUseItem

-     public class FactUseItem
      extends FactUse

  This is a concept item and the use of that concept item together. The use of the item may be for the beginning of a period, for the end of a period or normal use if there is no indication
  Author:
    Ignacio

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `BEGINNING` This constant indicates that the concept item is used at the beginning of this period.
    `static int` | `CLOSING_BOOKS_PREVIOUS_YEAR` This constant indicates that the concept item is used at the beginning/end of previous year.
    `static int` | `END` This constant indicates that the concept item is used at the end of this period.
    `static int` | `NEGATED` Flag indicating this item is negated.

    - ### Fields inherited from class com.ihr.xbrl.dts.FactUse

      `NORMAL`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FactUseItem(XBRLFactsList parent, XBRLItem item, int use, int index, boolean bNegated, RowKey key)` Instantiates a new fact use item.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object obj)`
    `static java.util.Collection<java.lang.String>` | `getBeginningOfPeriodRolesCollection()` Gets the beginning of period roles collection.
    `static java.util.Collection<java.lang.String>` | `getEndOfPeriodRolesCollection()` Gets the end of period roles collection.
    `int` | `getIndex()` Access to the index that indicates the nTh use of the same fact item.
    `XBRLItem` | `getItem()` Access to the item of this item use tuple.
    `int` | `getUse()` Access to the information about the item use The uses can be `CLOSING_BOOKS_PREVIOUS_YEAR`, `BEGINNING`, `END` or `FactUse.NORMAL`, bitmap.
    `static int` | `getUseFromRole(java.lang.String role)` The return value is one of, FactUse.NORMAL, FactUseItem.BEGINNING or FactUseItem.END
    `static int` | `getUseFromRole(XBRLRoleType role)` The return value is one of, FactUse.NORMAL, FactUseItem.BEGINNING or FactUseItem.END
    `int` | `hashCode()`
    `boolean` | `isNegated()` If this Fact Use is negated this method returns true.

    - ### Methods inherited from class com.ihr.xbrl.dts.FactUse

      `getParent, getRowKey`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### BEGINNING

          public static final int BEGINNING

      This constant indicates that the concept item is used at the beginning of this period.
      See Also:
        Constant Field Values

    - #### END

          public static final int END

      This constant indicates that the concept item is used at the end of this period.
      See Also:
        Constant Field Values

    - #### NEGATED

          public static final int NEGATED

      Flag indicating this item is negated.
      See Also:
        Constant Field Values

    - #### CLOSING_BOOKS_PREVIOUS_YEAR

          public static final int CLOSING_BOOKS_PREVIOUS_YEAR

      This constant indicates that the concept item is used at the beginning/end of previous year.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### FactUseItem

          public FactUseItem(XBRLFactsList parent,
                     XBRLItem item,
                     int use,
                     int index,
                     boolean bNegated,
                     RowKey key)

      Instantiates a new fact use item.
      Parameters:
        `parent` - the parent
        `item` - the item
        `use` - the use
        `index` - the index
        `bNegated` - the b negated
        `key` - the key

  - ### Method Detail

    - #### getUse

          public int getUse()

      Access to the information about the item use The uses can be `CLOSING_BOOKS_PREVIOUS_YEAR`, `BEGINNING`, `END` or `FactUse.NORMAL`, bitmap.
      Returns:
        the use

    - #### isNegated

          public boolean isNegated()

      If this Fact Use is negated this method returns true.
      Returns:
        boolean

    - #### getIndex

          public int getIndex()

      Access to the index that indicates the nTh use of the same fact item.
      Returns:
        integer. -1 if no index or no information.

    - #### getItem

          public XBRLItem getItem()

      Description copied from class: `FactUse`
      Access to the item of this item use tuple.
      Overrides:
        `getItem` in class `FactUse`
      Returns:
        the item

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `FactUse`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `FactUse`

    - #### getUseFromRole

          public static int getUseFromRole(XBRLRoleType role)

      The return value is one of, FactUse.NORMAL, FactUseItem.BEGINNING or FactUseItem.END
      Parameters:
        `role` - as XBRLRoleType
      Returns:
        constant integer

    - #### getUseFromRole

          public static int getUseFromRole(java.lang.String role)

      The return value is one of, FactUse.NORMAL, FactUseItem.BEGINNING or FactUseItem.END
      Parameters:
        `role` - as String
      Returns:
        constant integer

    - #### getBeginningOfPeriodRolesCollection

          public static java.util.Collection<java.lang.String> getBeginningOfPeriodRolesCollection()

      Gets the beginning of period roles collection.
      Returns:
        the beginning of period roles collection

    - #### getEndOfPeriodRolesCollection

          public static java.util.Collection<java.lang.String> getEndOfPeriodRolesCollection()

      Gets the end of period roles collection.
      Returns:
        the end of period roles collection